#!/usr/bin/python
import os
import fnmatch
from lxml import etree
import treecutter.constants as const

class Directory():
    """Class containing the state of the directory with articles"""
    def __init__(self):
        self._cwd = '.'
        self._tree = []

    def scan(self):
        for dirname, dirnames, filenames in os.walk(self._cwd):
            for filename in filenames:
                if fnmatch.fnmatch(filename, '*.xml'):
                    file_ = os.path.join(dirname,filename)
                    doc = etree.parse(file_)
                    title = doc.xpath(u'/db:article/db:info/db:title',namespaces=const.XPATH)
                    menu  = doc.xpath(u'/db:article/db:info/db:titleabbrev',namespaces=const.XPATH)
                    if title and menu:
                        base = file_.split('.')[1]
                        link = base.replace('index','')
                        self._tree.append(link)

    def set(self):
        return set(self._tree)
